<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

    <title>Open Source Licenses</title>
    <meta name="description" content="ESTP 2023 course, day 1: Open Source Licenses">
    <meta name="author" content="Ole Mussmann">

    <link rel="icon" type="image/x-icon" href="./files/favicon-32x32.png">

    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">

    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <link rel="stylesheet" href="dist/reset.css">
    <link rel="stylesheet" href="dist/reveal.css">

    <!-- theme -->
    <link rel="stylesheet" href="dist/theme/black.css" id="theme">
    <link rel="stylesheet" href="dist/theme/escience_4.3.1.css" id="theme">

    <!-- fonts -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Nunito">
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Assistant">
    <link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">

    <!-- Theme used for syntax highlighted code -->
    <link rel="stylesheet" href="plugin/highlight/monokai.css">

    <!-- Load jQuery -->
    <script
      src="https://code.jquery.com/jquery-3.4.1.min.js"
      integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo="
      crossorigin="anonymous"></script>
    <script src="http://localhost:35729/livereload.js"></script>

  </head>
  <body>
    <div class="reveal">
      <div class="slides">

        <section data-markdown data-state="blue_overlay 9 yellow_flag yellow_strip purple_half_circle_bottom purple_blob right_e_top" data-background-video="./files/Code_flythough_loop_01_Videvo.mov" data-background-video-loop data-background-video-muted="true">
<!-- https://www.videvo.net/video/computer-code-flythrough-loop/4519/ -->
<textarea data-template>

# Open Source Licenses

<br>
<br>

<a href="mailto:o.mussmann@esciencecenter.nl">Ole Mussmann</a> | <a href="https://www.esciencecenter.nl/">eScience Center</a> | <img style="height: 2.5vw; padding: 0 .5vw; margin-bottom: -.5vw; margin-top: -2vw;" src="./files/eu_logo.png"><img style="height: 2vw; margin-bottom: -.5vw; margin-top: -2vw;" src="./files/logo_icon.jpg">

</textarea>
</section>
<section>
<section data-markdown data-state="standard" data-background="./files/checklist-2589418_1920.jpg">
<!-- https://pixabay.com/photos/checklist-goals-box-notebook-pen-2589418/ -->
<textarea data-template>

## Table of Contents

- [License, what's that?](#/license)
- [Openness](#/openness)
- [Data (and other creative works)](#/creativecommons)
- [Software](#/software)
- [Compatibility](#/compatibility)
- [Summary](#/summary)
- [Resources](#/links)
- [💻 Exercise](#/exercise)


</textarea>
</section>
<section data-markdown data-state="logo yellow_flag black_overlay 5" data-background="./files/lady-justice-2388500_1920.jpg">
<textarea data-template>
<!-- https://pixabay.com/photos/lady-justice-legal-law-justice-2388500/ -->

## Disclaimer

- I am not a lawyer. This is not legal advice.
- Please ask your legal department about which licenses to choose and how to apply them.

<br>
<br>
<div class="fragment">
<b>Do not use your own license.</b>

You will make mistakes.<br>Others will not use it.
</div>

</textarea>
</section>
</section>

<section>
<section data-markdown data-state="standard" data-background="./files/software-7049425.png" id="license">
<!-- https://pixabay.com/vectors/software-license-system-program-7049425/ -->
<textarea data-template>

# What's a license?

Contract between creator and user of some creative work <!-- .element: class="fragment" -->

Notes:
Seems dry and boring, but a license gives you power!


</textarea>
</section>
<section data-markdown data-state="standard" data-background="./files/software-7049425.png" id="license">
<textarea data-template>
<!-- https://pixabay.com/vectors/software-license-system-program-7049425/ -->

## License Terms
<ul>
  <li>Are you allowed to use the work at all?</li>
  <li class="fragment">If you are, may you <b>use</b>, <b>copy</b>, <b>modify</b> or <b>distribute</b> it?</li>
  <div class="fragment">
    <li>Multiple licenses are possible</li>
    <ul>
      <li>E.g. using both commercial and open-source licenses</li>
    </ul>
    <li>Or different licenses to different parts of your project</li>
  </div>
  <div class="fragment">
    <li>You can change licenses in accordance with other contributors</li>
    <li>But assigned licenses are non-revocable</li>
  </div>
</ul>

</textarea>
</section>
<section data-markdown data-state="standard" data-background="./files/software-7049425.png">
<textarea data-template>
<!-- https://pixabay.com/vectors/software-license-system-program-7049425/ -->

## What if I don't assign a license?

- You keep the copyright
- Nobody may use, copy, modify or distribute your work
  - or face legal consequences! ⚖️

*This holds true for all other contributors as well* <!-- .element: class="fragment" -->

<footer style="font-size: small;">From <a href="https://choosealicense.com/non-software/">choosealicense.com/non-software</a> under <a href="https://creativecommons.org/licenses/by/3.0/">CC BY 3.0</a></footer>


</textarea>
</section>
</section>

<section data-markdown data-state="yellow_flag logo black_overlay 3" data-background="./files/question-mark-2492009_1920.jpg">
<textarea data-template>
<!-- https://pixabay.com/illustrations/question-mark-pile-questions-symbol-2492009/ -->

## What licenses do you know?

</textarea>
</section>

<section>
<section data-markdown data-state="logo yellow_flag black_overlay 8" data-background="./files/open-sign-1836961_1920.jpg" id="openness">
<!-- https://pixabay.com/photos/open-sign-neon-lights-illuminated-1836961/ -->
<textarea data-template>

# Degree of Openness


</textarea>
</section>
<section data-markdown data-state="logo yellow_flag black_overlay 8" data-background="./files/open-sign-1836961_1920.jpg">
<textarea data-template>
<!-- https://pixabay.com/photos/open-sign-neon-lights-illuminated-1836961/ -->

<div style="width: 49%; float: left;">
  <h3>Copyleft</h3>
  <ul>
    <li>Strong terms</li>
    <li>Derivative work must carry the same license</li>
    <li>"Viral" (spider plant-y)</li>
    <li>Example: <a href="https://www.gnu.org/licenses/gpl.html">GPL</a>, <a href="https://creativecommons.org/licenses/by-sa/4.0/">CC BY-SA</a></li>
  </ul>
</div>
<div class="fragment" style="width: 49%; float: right;">
  <h3>Permissive</h3>
  <ul>
    <li>Minimal restrictions</li>
    <li>Distribution also under different terms</li>
    <li>Permits reuse in proprietary software</li>
    <li>Examples: <a href="https://opensource.org/licenses/MIT">MIT</a>, <a href="https://creativecommons.org/share-your-work/public-domain/cc0/">CC 0</a></li>
  </ul>
</div>

</textarea>
</section>
</section>

<section>
<section data-markdown data-state="logo yellow_flag white_overlay" data-background="./files/brushes-3129361_1920.jpg" id="creativecommons">
<!-- https://pixabay.com/photos/brushes-painter-work-shop-bowl-3129361/ -->
<textarea data-template>

# Data
### and other creative works


</textarea>
</section>
<section data-markdown data-state="logo yellow_flag white_overlay" data-background="./files/brushes-3129361_1920.jpg">
<textarea data-template>
<!-- https://pixabay.com/photos/brushes-painter-work-shop-bowl-3129361/ -->

## Creative Commons

<style>
@import url('https://fonts.googleapis.com/css2?family=Noto+Sans+Mono:wght@600&display=swap');
</style> 

For non-software like documentation, books, data, images, ...

<div style="width:49%; float: right;">
  <img class="fragment" style="max-height: 25vh; max-width: 30vw; margin: 0; border: 2px solid black;" src="./files/475px-Creative_commons_license_spectrum.svg.png"/>
</div>
<div style="width:fit-content; float: right; text-align: left; padding: 0;">
  <img style="height: 1em; padding: 0; padding-top: 1em; margin: 0; margin-bottom: -.2em;" src="./files/Cc-zero.svg"/> | <span style="font-family: 'Noto Sans Mono', monospace;">0 </span> public domain<br style="margin-bottom: .5em;">
  Or combine<br style="margin-bottom: .25em;">
  <img style="height: 1em; padding: 0; margin: 0; margin-bottom: -.2em;" src="./files/Cc-by_new.svg"/> | <span style="font-family: 'Noto Sans Mono', monospace;">BY</span> attribution<br>
  <img style="height: 1em; padding: 0; margin: 0; margin-bottom: -.2em;" src="./files/Cc-sa.svg"/> | <span style="font-family: 'Noto Sans Mono', monospace;">SA</span> share alike<br> 
  <img style="height: 1em; padding: 0; margin: 0; margin-bottom: -.2em;" src="./files/Cc-nc.svg"/> | <span style="font-family: 'Noto Sans Mono', monospace;">NC</span> non-commercial<br> 
  <img style="height: 1em; padding: 0; margin: 0; margin-bottom: -.2em;" src="./files/Cc-nd.svg"/> | <span style="font-family: 'Noto Sans Mono', monospace;">ND</span> no derivative works
</div>
<div style="text-align: left; width: fit-content; margin-left: auto; float: left;">
</div>

<footer>Image by <a href="https://commons.wikimedia.org/wiki/File:Creative_commons_license_spectrum.svg">Shaddim; original CC license symbols by Creative Commons</a>, <a href="https://creativecommons.org/licenses/by/4.0">CC BY 4.0</a>, via Wikimedia Commons</footer>


</textarea>
</section>
<section data-markdown data-state="logo yellow_flag clear_background" data-background-iframe="https://chooser-beta.creativecommons.org/">
<textarea data-template>
<footer><a href="https://chooser-beta.creativecommons.org">chooser-beta.creativecommons.org</a></footer>

</textarea>
</section>
</section>

<section>
<section data-markdown data-state="logo yellow_flag black_overlay 7" data-background="./files/matrix-1735640_1920.jpg" id="software">
<!-- https://pixabay.com/illustrations/matrix-code-data-networking-1735640/ -->
<textarea data-template>

# Software Licenses

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag black_overlay 7" data-background="./files/matrix-1735640_1920.jpg">
<textarea data-template>
<!-- https://pixabay.com/illustrations/matrix-code-data-networking-1735640/ -->

## General terms
### of most software licenses
- Permissions 
  - Commercial use, private use, distribution, modification
- Conditions <!-- .element: class="fragment" -->
  - Include license and copyright notice *when distributing*
- Limitation <!-- .element: class="fragment" -->
  - Liability, warranty

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag black_overlay 7" data-background="./files/matrix-1735640_1920.jpg">
<textarea data-template>
<!-- https://pixabay.com/illustrations/matrix-code-data-networking-1735640/ -->

## GPLv2

- Conditions
  - Disclose source, same license, state changes

~ 3000 words

<br>

<div class="fragment">
  <h2>LGPLv2.1 (Lesser GPL)</h2>

Same as GPL, but has no constraints *when used as a library*

~ 4000 words

Share: <b>~25%</b> <sup>[1]</sup>
</div>


<footer>[1] <a href="https://www.whitesourcesoftware.com/resources/blog/open-source-licenses-trends-and-predictions/">whitesourcesoftware.com</a>, 2021, all GPL and LGPL versions combined</footer>

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag black_overlay 7" data-background="./files/matrix-1735640_1920.jpg">
<textarea data-template>
<!-- https://pixabay.com/illustrations/matrix-code-data-networking-1735640/ -->

## Apache 2.0

- Permissions
  - Patent use
- Conditions
  - State changes
- Limitation
  - Trademark use (does not grant trademark rights)

~ 1400 words

Share: <b>~34%</b> <sup>[1]</sup>

<footer>[1] <a href="https://www.whitesourcesoftware.com/resources/blog/open-source-licenses-trends-and-predictions/">whitesourcesoftware.com</a>, 2021</footer>

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag black_overlay 7" data-background="./files/matrix-1735640_1920.jpg">
<textarea data-template>
<!-- https://pixabay.com/illustrations/matrix-code-data-networking-1735640/ -->

## MIT License
<br>
simple

<br>
<br>

~ 170 words

Share: <b>~30%</b> <sup>[1]</sup>

<footer>[1] <a href="https://www.whitesourcesoftware.com/resources/blog/open-source-licenses-trends-and-predictions/">whitesourcesoftware.com</a>, 2021</footer>


</textarea>
</section>
</section>

<section>
<section data-markdown data-state="standard" data-background="./files/sim-card-4475649_1920.jpg" id="compatibility">
<!-- https://pixabay.com/photos/sim-card-card-memory-micro-sd-4475649/ -->
<textarea data-template>

# License compatibility

</textarea>
</section>
<section data-markdown .slide: data-state="standard" data-background="./files/sim-card-4475649_1920.jpg">
<textarea data-template>
<!-- https://pixabay.com/photos/sim-card-card-memory-micro-sd-4475649/ -->

## Can I apply another license?

Rule of thumb: you can restrict more, but not open up again

<img style="height: 25vh; padding: 0; margin: 0;" src="./files/Floss-license-slide-image.svg"/>

The same holds true if others use your software! <!-- .element class="fragment" -->

<footer>Image by  David A. Wheeler, <a href="https://creativecommons.org/licenses/by-sa/3.0/deed.en">CC BY-SA 3.0</a></footer>

</textarea>
</section>
<section data-markdown data-state="standard" data-background="./files/sim-card-4475649_1920.jpg">
<textarea data-template>
<!-- https://pixabay.com/photos/sim-card-card-memory-micro-sd-4475649/ -->

## Is my work affected when re-using open source software?

<img style="height: 25vh;" src="./files/Software-license-compatiblity-graph.svg"/>

</textarea>
</section>
</section>

<section data-markdown data-state="standard 4" data-background="./files/note-pad-1215425_1920.jpg" id="summary">
<!-- https://pixabay.com/illustrations/note-pad-pen-coffee-cup-plant-1215425/ -->
<textarea data-template>

<div style="transform: rotate(-5deg); width: 72%; float: left; margin-left: 2vw;">
<h2>Summary</h2>
<ul>
  <li>Use a popular, existing license</li>
  <ul>
    <li>Follow the licenses of the ecosystem!</li>
  </ul>
  <li>Main flavors are</li>
  <ul>
    <li>Copyleft for control</li>
    <li>Permissive for adoption</li>
  </ul>
  <li>Software and data have different licenses</li>
  <li>Licenses cannot be revoked</li>
  <li>Licenses for future work can be changed in accordance with contributors</li>
</ul>
</div>

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag black_overlay" data-background="./files/earth-3537401_1920.jpg" id="links">
<!-- https://pixabay.com/illustrations/earth-network-blockchain-globe-3537401/ -->
<textarea data-template>

# Resources

- https://choosealicense.com/
- https://choosealicense.com/appendix/
- https://opensource.org/licenses
- https://tldrlegal.com/

</textarea>
</section>
<section>
<section data-markdown data-state="logo yellow_flag black_overlay 6" data-background="./files/man-2264825_1920.jpg" id="exercise">
<!-- https://pixabay.com/photos/man-woman-push-ups-wellness-2264825/ -->
<textarea data-template>

# Exercise

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag black_overlay 6" data-background="./files/man-2264825_1920.jpg">
<textarea data-template>
<!-- https://pixabay.com/photos/man-woman-push-ups-wellness-2264825/ -->

### Which situations are problematic? Why?

<div style="font-size: medium;">

1. Copy code from minty-amqp (EUPL 1.2 license)  
    1.1. and use it for your weather station hobby project, you are the only user so far and the code is private  
    1.2. and distribute the weather station project to your friends who became super enthousiastic to build their own

2. Import numpy (BSD license)  
   2.1. and use it in your own, unpublished software at work  
   2.2. and create a package that you publish on pypi.org

3. Import keras (MIT license)   
   3.1. and put a machine learning model generated by your code on github.com  
   3.2. and create an executable with nuitka (https://nuitka.net) and sell it on ebay

4. Import sshconfig (GPLv3+ license)  
   4.1. and post a script using it on reddit  
   4.2. and use it in your MIT licensed project at work

5. You want to publish a completed project at work under the Apache 2.0 license soon  
   5.1. the project is using MIT licensed code, as well as code in the public domain  
   5.2. an unpaid intern that helped creating the project left two weeks ago

6. You created a database system and published the core under the AGPL license, leaving support and extended services as your business model  
   6.1. it is so successful that Google is offering it to customers directly as it is  
   6.2. now even Amazon is on board, re-built the extended services and offers it as a Software-as-a-Service package to end-users
</div>

</textarea>
</section>
</section>
      </div>
    </div>

    <script src="dist/reveal.js"></script>

    <script src="plugin/highlight/highlight.js"></script>
    <script src="plugin/markdown/markdown.js"></script>
    <script src="plugin/math/math.js"></script>
    <script src="plugin/notes/notes.js"></script>
    <script src="plugin/search/search.js"></script>
    <script src="plugin/zoom/zoom.js"></script>
    <!--
    <script src="reveal.js/4.3.1/reveal.js-plugins/menu/menu.js"></script>
    -->

    <script src="dist/escience.js"></script>

    <script>
      // More info about initialization & config:
      // - https://revealjs.com/initialization/
      // - https://revealjs.com/config/
      Reveal.initialize({
        hash: true,

        // Automatically activate the scroll view when we the viewport falls
        // below the given width.
        scrollActivationWidth: 0,  // disabled

        // Force the scrollbar to remain visible
        scrollProgress: true,

        // Learn about plugins: https://revealjs.com/plugins/
        plugins: [ RevealMarkdown, RevealHighlight, RevealNotes ]
      });
    </script>
  </body>
</html>
